void loop() {

  Blynk.run();
  blynkUpdate1 ();
  blynkUpdate2 ();
  blynkUpdate3 ();
temperatureFunction2 ();
  //TEMPERATURE SETTINGS
  //temperature = message2;


  //Switch on the heaters if the function calls for this

  digitalWrite(heaterElement1, heater1);
  digitalWrite(stirrerElement, stirrer);
  digitalWrite(D5, heater1);


//Serial.print("temp stage1: ");
//Serial.println(mashTempStage1);
//Serial.print("temp stage2: ");
//Serial.println(mashTempStage2);
//Serial.print("temp stage3: ");
//Serial.println(mashTempStage3);
//Serial.print("temp stage4: ");
//Serial.println(mashTempStage4);




  timeNow = millis() / 1000; // the number of milliseconds that have passed since boot
  seconds = timeNow - timeLast;//the number of seconds that have passed since the last time 60 seconds was reached.
  if (seconds >= 60) {
    timeLast = timeNow;
    minutes = minutes + 1;
    minutesCounter = minutesCounter + 1;
  }
  //if one minute has passed, start counting milliseconds from zero again and add one minute to the clock.
  if (minutes >= 60) {
    minutes = 0;
    hours = hours + 1;
  }
  // if one hour has passed, start counting minutes from zero and add one hour to the clock
  if (hours == 24) {
    hours = 0;
    days = days + 1;
  }
  //if 24 hours have passed , add one day

  if (hours == (24 - startingHour) && correctedToday == 0) {
    delay(dailyErrorFast * 1000);
    seconds = seconds + dailyErrorBehind;
    correctedToday = 1;
  }
  //every time 24 hours have passed since the initial starting time and it has not been reset this day before, add milliseconds or delay the progran with some milliseconds.
  //Change these varialbes according to the error of your board.
  // The only way to find out how far off your boards internal clock is, is by uploading this sketch at exactly the same time as the real time, letting it run for a few days
  // and then determine how many seconds slow/fast your boards internal clock is on a daily average. (24 hours).
  if (hours == 24 - startingHour + 2) {
    correctedToday = 0;
  }


  // read the value of the switch
  // digitalRead() checks to see if there is voltage
  // on the pin or not
  switch1 = digitalRead(D6);

 
  
  if (switch1 == HIGH) {
    switchState = HIGH;
  }


  //Serial.print("Minutes: " );
  //Serial.println(minutesCounter );
  //Serial.print("Brewstage : " );
  //Serial.println(brewStage );
  //Serial.print("switchstate: " );
  //Serial.println(switchState );
  //Serial.print("switch1: " );
  //Serial.println(switch1 );
  //Serial.print("Temperature: " );
  //Serial.println(temperature );


  //BELOW THE VARIOUS BREW STAGES AND WHAT THE PROGRAM DOES during
  // 0 is standby, 1 is heating strike water, 2 is waiting for mash, 3 is mashing, 4 is extracting mash bag and waiting for boil,
  //5 is heating towards boil, 6 is boil, 7 is Ice cooling, 8 is pitching, 9 is primary ferment, 10 is secondary ferment, 11 is bottle

  switch (brewStage) {

    case 0:
      //spusteni varny
      display.setTextSize(1);
      display.setTextColor(WHITE);
      display.setCursor(0, 0);
      display.println("  BREWERY ");
      display.println("   READY  ");
      display.setTextColor(BLACK, WHITE); // 'inverted' text
      display.println("   Hold   ");
      display.println("  Button  ");
      display.println(" to START ");
      display.display();
      delay(5);
      display.clearDisplay();

      LCD1 = "Brewery is ready";
      LCD2 = "Press the button!";
      

      if (brewStage == 0 && switchState == HIGH) {
        brewStage = 1;

        terminal.println("PREPARING STRIKE WATER.");
        terminal.flush();
        Blynk.notify(String("Heating strike water"));
        minutesCounter = 0;
        buzzer = HIGH;
        buzzer = LOW;
      }
      break;

    case 1:
      //heating to stage1

      display.setTextSize(1);
      display.setTextColor(WHITE);
      display.setCursor(0, 0);
      display.println(" HEATING");
      display.println();
      display.setTextColor(BLACK, WHITE); // 'inverted' text
      display.print(" ET ");
      display.print(timeEstimate);
      display.println("min");
      display.print("  ");
      display.print(temperature);
      display.println("'C ");
      display.println("   total: ");
      display.print("   ");
      display.print(hours);
      display.print(":");
      display.print(minutes);
      display.print(":");
      display.print(seconds);
      display.println(" ");
      display.display();
      delay(5);
      display.clearDisplay();

      LCD1 = "Heating the";
      LCD2 = "Strike water";
      TempStage = mashTempStage1;
      timeTempEST = (((TempStage - temperature) * (liters) * 4 / 3412) * 60 / KiloWatt);
      timeEstimate = timeTempEST;
      //timeTemp = (mashTemp - temperature) / ((KiloWatt * 3412) / (liters * 4) / 60);
      //timeEstimate = timeTemp - minutesCounter;
      //find this formula and a great calculator at https://elementsofheating.wordpress.com/2012/09/26/how-to-calculate-the-kw-required-to-heat-a-volume-of-water-in-a-particular-time/

      heater1 = LOW;
      stirrer = LOW;
      CheckSensorTemp();
      
      
      if (brewStage == 1 && temperature > mashTempStage1) {

        heater1 = HIGH;
        //stirrer = HIGH;
        minutesCounter = 0;  
        switchState = 0;
        brewStage = 2;
        terminal.println("ADD THE GRAINS TO KETTLE AND PRESS BUTTON FOR START THE MASH.");
        terminal.flush();

        Blynk.notify(String("Add The grains now"));

        buzzer = HIGH;
        buzzer = LOW;
      }
      break;


    case 2:
      //waiting to add grains
      display.setTextSize(1);
      display.setTextColor(WHITE);
      display.setCursor(0, 0);
      display.println("  STRIKE ");
      display.println("   READY  ");
      display.println();
      display.setTextColor(BLACK, WHITE); // 'inverted' text
      display.println("   Hold   ");
      display.println("  Button  ");
      display.println("  to MASH ");
      display.display();
      delay(5);
      display.clearDisplay();
      TempStage = mashTempStage1;
      LCD1 = "ADD the grains";
      LCD2 = "Press the button";

      if ( temperature < mashTempStage1 - 2) {
        heater1 = LOW;
      }

      else if ( temperature > mashTempStage1 + 2 ) {
        heater1 = HIGH;
      }
      CheckSensorTemp();
      if (brewStage == 2 && switchState == HIGH) {
        brewStage = 3;
        terminal.println("OPEN BEER AND BE PATIENT.");

        terminal.flush();
        minutesCounter = 0;
        //timeEstimate = 0;

        buzzer = HIGH;
        buzzer = LOW;
      }
      break;
    case 3:
      //mashing stage1
      if ( temperature < mashTempStage1) {
        heater1 = LOW;
      }

      else if (temperature > mashTempStage1) {
        heater1 = HIGH;
      }

      display.setTextSize(1);
      display.setTextColor(WHITE);
      display.setCursor(0, 0);
      display.println(" MASHING 1");
      display.println();
      display.setTextColor(BLACK, WHITE); // 'inverted' text
      
      display.print(" RT ");
      display.print(timeEstimate);
      display.println("min");
      display.print("  ");
      display.print(temperature);
      display.println("'C ");
      display.println("   total: ");
      display.print("   ");
      display.print(hours);
      display.print(":");
      display.print(minutes);
      display.print(":");
      display.print(seconds);
      display.println(" ");
      display.display();
      delay(5);
      display.clearDisplay();
      TempStage = mashTempStage1;
      TimeStage = mashTimeStage1;
      LCD1 = "Mashing grains";
      LCD2 = "Stage1";
      
      timeEstimate = mashTimeStage1 - minutesCounter;
      CheckSensorTemp();
      if (minutesCounter > mashTimeStage1) {
        brewStage = 4;
       terminal.println("OPEN SECOND BEER :-)");
       minutesCounter = 0;  
      }
      break;

  case 4:
      //heating to stage2
      display.setTextSize(1);
      display.setTextColor(WHITE);
      display.setCursor(0, 0);
      display.println("  HEATING ");
      display.println(" TO STAGE2");
      display.setTextColor(BLACK, WHITE); // 'inverted' text
      
      display.print(" ET ");
      display.print(timeEstimate);
      display.println("min");
      display.print("  ");
      display.print(temperature);
      display.println("'C ");
      display.println("   total: ");
      display.print("   ");
      display.print(hours);
      display.print(":");
      display.print(minutes);
      display.print(":");
      display.print(seconds);
      display.println(" ");
      display.display();
      delay(5);
      display.clearDisplay();
      TempStage = mashTempStage2;
      timeTempEST = (mashTempStage2 - temperature) / ((KiloWatt * 3412) / (liters * 4) / 60);
      timeEstimate = timeTempEST;
      LCD1 = "Heating to STAGE";
      LCD2 = "2 Wait for it!";
      heater1 = LOW;
      stirrer = LOW;
    
      CheckSensorTemp();

      if (brewStage == 4 && mashTimeStage2 == 0) {

        
        switchState = 0;
        brewStage = 6;
        minutesCounter = 0;

        buzzer = HIGH;
        buzzer = LOW;
      }
     if (brewStage == 4 && temperature > mashTempStage2) {
        brewStage = 5;

        terminal.println("");

        terminal.flush();
        minutesCounter = 0;
        //timeEstimate = 0;

        buzzer = HIGH;
        buzzer = LOW;
      }
      break;



      

case 5:
      //mashing stage2
      if ( temperature < mashTempStage2) {
        heater1 = LOW;
      }

      else if (temperature > mashTempStage2) {
        heater1 = HIGH;
      }

      display.setTextSize(1);
      display.setTextColor(WHITE);
      display.setCursor(0, 0);
      display.println(" MASHING 2");
      display.println();
      display.setTextColor(BLACK, WHITE); // 'inverted' text
      
      display.print(" RT ");
      display.print(timeEstimate);
      display.println("min");
      display.print("  ");
      display.print(temperature);
      display.println("'C ");
      display.println("   total: ");
      display.print("   ");
      display.print(hours);
      display.print(":");
      display.print(minutes);
      display.print(":");
      display.print(seconds);
      display.println(" ");
      display.display();
      delay(5);
      display.clearDisplay();
      TempStage = mashTempStage2;
      TimeStage = mashTimeStage1;
      LCD1 = "Mashing grains";
      LCD2 = "Stage 2";

      timeEstimate = mashTimeStage2 - minutesCounter;
      CheckSensorTemp();
      if (brewStage == 5 && mashTimeStage2 == 0) {
        switchState = 0;
        brewStage = 6;
        minutesCounter = 0;

        buzzer = HIGH;
        buzzer = LOW;
      }
      if (minutesCounter > mashTimeStage2) {
        brewStage = 6;  
      minutesCounter = 0;  

      }
      break;

      case 6:
      //heating to stage3
      display.setTextSize(1);
      display.setTextColor(WHITE);
      display.setCursor(0, 0);
      display.println("  HEATING ");
      display.println(" TO STAGE3");
      display.setTextColor(BLACK, WHITE); // 'inverted' text
      
      display.print(" ET ");
      display.print(timeEstimate);
      display.println("min");
      display.print("  ");
      display.print(temperature);
      display.println("'C ");
      display.println("   total: ");
      display.print("   ");
      display.print(hours);
      display.print(":");
      display.print(minutes);
      display.print(":");
      display.print(seconds);
      display.println(" ");
      display.display();
      delay(5);
      display.clearDisplay();
      TempStage = mashTempStage3;
      timeTempEST = (mashTempStage3 - temperature) / ((KiloWatt * 3412) / (liters * 4) / 60);
      timeEstimate = timeTempEST;
      LCD1 = "Heating to STAGE";
      LCD2 = "3 Wait for it!";
      heater1 = LOW;
      stirrer = LOW;
    
      CheckSensorTemp();
      if (brewStage == 6 && mashTimeStage3 == 0) {

        
        switchState = 0;
        brewStage = 8;
        minutesCounter = 0;

        buzzer = HIGH;
        buzzer = LOW;
      }
     if (brewStage == 6 && temperature > mashTempStage3) {
        brewStage = 7;

        terminal.println("");

        terminal.flush();
        minutesCounter = 0;
        //timeEstimate = 0;

        buzzer = HIGH;
        buzzer = LOW;
      }
      break;



case 7:
      //mashing stage3
      if ( temperature < mashTempStage3) {
        heater1 = LOW;
      }

      else if (temperature > mashTempStage3) {
        heater1 = HIGH;
      }

      display.setTextSize(1);
      display.setTextColor(WHITE);
      display.setCursor(0, 0);
      display.println(" MASHING 3");
      display.println();
      display.setTextColor(BLACK, WHITE); // 'inverted' text
      
      display.print(" RT ");
      display.print(timeEstimate);
      display.println("min");
      display.print("  ");
      display.print(temperature);
      display.println("'C ");
      display.println("   total: ");
      display.print("   ");
      display.print(hours);
      display.print(":");
      display.print(minutes);
      display.print(":");
      display.print(seconds);
      display.println(" ");
      display.display();
      delay(5);
      display.clearDisplay();
      display.clearDisplay();
      TempStage = mashTempStage3;
      TimeStage = mashTimeStage3;
      LCD1 = "Mashing grains";
      LCD2 = "Stage 3";
      CheckSensorTemp();
      timeEstimate = mashTimeStage3 - minutesCounter;
      if (brewStage == 7 && mashTimeStage3 == 0) {

        
        switchState = 0;
        brewStage = 8;
        minutesCounter = 0;

        buzzer = HIGH;
        buzzer = LOW;
      }

      if (minutesCounter > mashTimeStage3) {
        brewStage = 8;
        terminal.println("");
        terminal.flush();
        
        minutesCounter = 0;
        buzzer = HIGH;
        buzzer = LOW;
        switchState = 0;
        minutesCounter = 0;
        //timeEstimate = 0;

      }
      break;


case 8:
      //heating to stage4
      display.setTextSize(1);
      display.setTextColor(WHITE);
      display.setCursor(0, 0);
      display.println("  HEATING ");
      display.println(" TO STAGE4");
      display.setTextColor(BLACK, WHITE); // 'inverted' text
      
      display.print(" ET ");
      display.print(timeEstimate);
      display.println("min");
      display.print("  ");
      display.print(temperature);
      display.println("'C ");
      display.println("   total: ");
      display.print("   ");
      display.print(hours);
      display.print(":");
      display.print(minutes);
      display.print(":");
      display.print(seconds);
      display.println(" ");
      display.display();
      delay(5);
      display.clearDisplay();
      TempStage = mashTempStage4;
      TimeStage = mashTimeStage4;
      timeTempEST = (TempStage - temperature) / ((KiloWatt * 3412) / (liters * 4) / 60);
      timeEstimate = timeTempEST;
      LCD1 = "Heating to STAGE";
      LCD2 = "4 Wait for it!";
      heater1 = LOW;
      stirrer = LOW;
    
      CheckSensorTemp();
       if (brewStage == 8 && mashTimeStage4 == 0) {

        
        switchState = 0;
        brewStage = 10;
        minutesCounter = 0;

        buzzer = HIGH;
        buzzer = LOW;
      }
     if (brewStage == 8 && temperature > mashTempStage4) {
        brewStage = 9;
        terminal.println("OPEN BEER AND BE PATIENT.");

        terminal.flush();
        minutesCounter = 0;
        //timeEstimate = 0;

        buzzer = HIGH;
        buzzer = LOW;
      }
      break;



case 9:
      //mashing stage4
      if ( temperature < mashTempStage4) {
        heater1 = LOW;
      }

      else if (temperature > mashTempStage4) {
        heater1 = HIGH;
      }

      display.setTextSize(1);
      display.setTextColor(WHITE);
      display.setCursor(0, 0);
      display.println(" MASHING 4");
      display.println();
      display.setTextColor(BLACK, WHITE); // 'inverted' text
      
      display.print(" RT ");
      display.print(timeEstimate);
      display.println("min");
      display.print("  ");
      display.print(temperature);
      display.println("'C ");
      display.println("   total: ");
      display.print("   ");
      display.print(hours);
      display.print(":");
      display.print(minutes);
      display.print(":");
      display.print(seconds);
      display.println(" ");
      display.display();
      delay(5);
      display.clearDisplay();
      TempStage = mashTempStage4;
      TimeStage = mashTimeStage4;
      LCD1 = "Mashing grains";
      LCD2 = "Stage 4";
      CheckSensorTemp();
      timeEstimate = mashTimeStage4 - minutesCounter;
      
      if (brewStage == 9 && mashTimeStage4 == 0) {

        
        switchState = 0;
        brewStage = 10;
        minutesCounter = 0;

        buzzer = HIGH;
        buzzer = LOW;
      }

      if (minutesCounter > mashTimeStage4) {
        brewStage = 10;
        terminal.println("TIME FOR LAUTERING AND SPARGING ");
        terminal.flush();
        
        Blynk.notify(String("MASHOUT!"));
        minutesCounter = 0;
        buzzer = HIGH;
        buzzer = LOW;
        switchState = 0;
        minutesCounter = 0;
        //timeEstimate = 0;

      }
      break;



    case 10:
      //What to do when Brewstage equals 4
      display.setTextSize(1);
      display.setTextColor(WHITE);
      display.setCursor(0, 0);
      display.println("MASHOUT");
      display.println("SPARGING");
      display.setTextColor(BLACK, WHITE); // 'inverted' text
      display.println("   Press  ");
      display.println("   Button ");
      display.println("  To Boil ");
      display.display();
      delay(5);
      display.clearDisplay();
      TempStage = boilTemp;
      TimeStage = boilTime;
      heater1 = HIGH;
      stirrer = HIGH;
      CheckSensorTemp();
      LCD1 = "Mashout and sparging";
      LCD2 = "press button to boil";

      if (brewStage == 10 && switchState == HIGH){

        brewStage = 11;
        switchState = 0;
        terminal.println("HEATING THE WATER TO BOILING POINT");
        Blynk.notify(String("The strike water is being heated "));
        //timeTemp = (mashTemp - temperature) / ((KiloWatt * 3412) / (liters * 4) / 60);
        //timeEstimate = boilTime - minutesCounter;
        //find this formula and a great calculator at https://elementsofheating.wordpress.com/2012/09/26/how-to-calculate-the-kw-required-to-heat-a-volume-of-water-in-a-particular-time/

        terminal.flush();
        buzzer = HIGH;
        buzzer = LOW;
        switchState = 0;
         minutesCounter = 0;
      }
      break;
    case 11:
      //What to do when Brewstage equals 5
      heater1 = LOW;
      stirrer = LOW;
      CheckSensorTemp();
      display.setTextSize(1);
      display.setTextColor(WHITE);
      display.setCursor(0, 0);
      display.println("  HEATING");
      display.println("  TO BOIL");
      display.setTextColor(BLACK, WHITE); // 'inverted' text
      display.print(" ET ");
      display.print(timeEstimate);
      display.println("min");
      display.print("  ");
      display.print(temperature);
      display.println("'C ");
      display.println("   total: ");
      display.print("   ");
      display.print(hours);
      display.print(":");
      display.print(minutes);
      display.print(":");
      display.print(seconds);
      display.println(" ");
      display.display();
      delay(5);
      display.clearDisplay();

      LCD1 = "HEATING ";
      LCD2 = "Boil water";
      timeTempEST = (boilTemp - temperature) / ((KiloWatt * 3412) / (liters * 4) / 60);
      timeEstimate = timeTempEST - minutesCounter;
      //timeTemp = (boilTemp - temperature) / ((KiloWatt * 3412) / (liters * 4) / 60);
      //timeEstimate = timeTemp - minutesCounter;
      //find this formula and a great calculator at https://elementsofheating.wordpress.com/2012/09/26/how-to-calculate-the-KiloWatt-required-to-heat-a-volume-of-water-in-a-particular-time/

      if (temperature > (boilTemp)) {

        brewStage = 12;
        terminal.println("THE BOIL HAS STARTED, NOTICE THAT YOU NEED TO ADD THE HOPS AT VARIOUS POINTS DURING THE BOIL. I RECOMMEND DOING THIS IN HOP BAGS OR LARGE TEABAGS SO YOU CAN FILTER THEM OUT AFTERWARDS. NOTICE THAT HOPS WILL SWELL");
        terminal.flush();
        Blynk.notify(String("The boil has started"));
        minutesCounter = 0;
        //timeEstimate = 0;
        buzzer = HIGH;
        buzzer = LOW;
      }
      break;
    case 12:
      //What to do when Brewstage equals 6
      heater1 = LOW;
      stirrer = LOW;
      CheckSensorTemp();
      display.setTextSize(1);
      display.setTextColor(WHITE);
      display.setCursor(0, 0);
      display.println(" BOILING");
      display.println();
      display.setTextColor(BLACK, WHITE); // 'inverted' text
      display.print(" RT ");
      display.print(timeEstimate);
      display.println("min");
      display.print("  ");
      display.print(temperature);
      display.println("'C ");
      display.println("   total: ");
      display.print("   ");
      display.print(hours);
      display.print(":");
      display.print(minutes);
      display.print(":");
      display.print(seconds);
      display.println(" ");
      display.display();
      delay(5);
      display.clearDisplay();

      LCD1 = "Boiling";
      LCD2 = "The Wort";

      timeEstimate = boilTime - minutesCounter;

      if (minutesCounter >= HopTime1 && hop == 1) {

        terminal.println("ADD HOP 1");
        terminal.flush();
        Blynk.notify(String("ADD HOP 1"));
        hop = 2;
      }

      if (minutesCounter >= HopTime2 && hop == 2) {

        terminal.println("ADD HOP 2");
        terminal.flush();
        Blynk.notify(String("ADD HOP 2"));
        hop = 3;
      }

      if (minutesCounter >= HopTime3 && hop == 3) {

        terminal.println("ADD HOP 3");
        terminal.flush();
        Blynk.notify(String("ADD HOP 3"));
        hop = 4;
      }

      if (minutesCounter >= HopTime4 && hop == 4) {

        terminal.println("ADD HOP 4");
        terminal.flush();
        Blynk.notify(String("ADD HOP 4"));
        hop = 5;
      }




      if (minutesCounter > boilTime) {

        heater1 = HIGH;
        stirrer = HIGH;

        brewStage = 13;
        terminal.println("THE BOIL IS FINISHED, START COOLING BY ADDING ICE IN SEALED STERELISED CONTAINERS! CHECK DISPLAY FOR REQUIRED AMOUNT OF ICE");
        terminal.flush();
        Blynk.email("insertyouremail@email.com", "Boil finished", "Go add Ice you big boy.");
        Blynk.notify(String("The boil has finished, add ice now! "));
        buzzer = HIGH;
        buzzer = LOW;
        minutesCounter = 0;
        //timeEstimate = 0;
      }
      break;
    case 13:
      //What to do when Brewstage equals 7
      IceFunction(); //Call the function that calculates how much ice is needed.

      display.setTextSize(1);
      display.setTextColor(WHITE);
      display.setCursor(0, 0);
      display.println("  ADD ICE ");
      display.println();
      display.setTextColor(BLACK, WHITE); // 'inverted' text
      display.println(minutesCounter);
      display.println(temperature);
      display.print ("Add ");
      display.print(iceNeeded);
      display.println(" L ice");
      display.print(hours);
      display.print(":");
      display.print(minutes);
      display.print(":");
      display.println(seconds);
      display.display();
      delay(5);
      display.clearDisplay();

      LCD1 = "Boil finished";
      LCD2 = "ADD ICE";

      if (temperature <= (yeastPitchTemperature)) {

        brewStage = 14;
        terminal.println("YOU CAN NOW MOVE THE WORT TO THE FERMENTER AND PITCH THE YEAST, BUT STIR THE WORT FIRST TO GET OXYGEN AND TO ENSURE EVEN TEMPERATURE. DOUBLE CHECK THE TEMPERATURE MANUALLY IN THE FERMENTER AND TRANSFER THE TEMP SENSOR TO THE FERMENTER BEFORE PITCHING");
        terminal.flush();
        Blynk.email("insertyouremail@email.com", "Wort ready", "You can now move the wort to the fermenter and pitch the yeast.");
        Blynk.notify(String("The wort is ready "));

        buzzer = HIGH;
        buzzer = LOW;
        minutesCounter = 0;
        //timeEstimate = 0;
      }
      break;
    case 14:
      //What to do when Brewstage equals 8


      display.setTextSize(1);
      display.setTextColor(WHITE);
      display.setCursor(0, 0);
      display.println(" FERMENTING");
      display.println();
      display.setTextColor(BLACK, WHITE); // 'inverted' text
      display.println("days:");
      display.println(days);
      display.println(temperature);
      display.print(hours);
      display.print(":");
      display.print(minutes);
      display.print(":");
      display.println(seconds);
      display.display();
      delay(5);
      display.clearDisplay();

      LCD1 = " Yeast added";
      LCD2 = "Now Fermenting";

    

      if ((fermentTimeprimary - days) <= 0) {
        terminal.println("PRIMARY FERMENTATION DONE, MOVE TO SECONDARY OR BOTTLE. ADD SUGAR OR CO2 BEFORE BOTTLEING");
        terminal.flush();
        Blynk.email("insertyouremail@email.com", "Brew Ready", "The fermentation time is over, the brew is ready.");
        brewStage = 15;
      }
      break;
    case 15:

      display.setTextSize(1);
      display.setTextColor(WHITE);
      display.setCursor(0, 0);
      display.println(" FINISHED");
      display.println();
      display.setTextColor(BLACK, WHITE); // 'inverted' text
      display.println("days:");
      display.println(days);
      display.println(temperature);
      display.print(hours);
      display.print(":");
      display.print(minutes);
      display.print(":");
      display.println(seconds);
      display.display();
      delay(5);
      display.clearDisplay();

      LCD1 = "BEER IS READY";
      LCD2 = "ADD SUGAR OR CO2";
      break;
    case 16:
      //What to do when Brewstage equals 10
      break;
    case 17:
      //What to do when Brewstage equals 11
      break;
    default:
      // if nothing else matches, do the default
      // default is optional
      break;
  }




}// end void loop

